
/* global variables */
#include "npbparams.h"


#define FFTBLOCK_DEFAULT  32
#define FFTBLOCKPAD_DEFAULT 33

#define FFTBLOCK  FFTBLOCK_DEFAULT
#define FFTBLOCKPAD FFTBLOCKPAD_DEFAULT

/* timing instrumentation */
#define TIMERS_ENABLED  TRUE

#define T_TOTAL     0
#define T_FFT_INIT  1
#define T_FFT       2
#define T_EVOLVE    3
#define T_CHECKSUM  4
#define T_FFTLOW    5
#define T_FFTCOPY   6
#define T_INDEXMAP  7
#define T_INITCOND 	8
#define T_TRANSPOSE 9
#define T_ALLTOALL  10
#define T_MAX       11

/* other stuff */

#define SEED  314159265.0
#define A 1220703125.0
#define PI  3.141592653589793238
#define ALPHA 1.0e-6

/* COMMON block: ucomm */
/* used in fft_init(), cfftz(), fftz2() */
dcomplex u[NX];

typedef struct d_cell_s d_cell_t;
struct d_cell_s {
  double cell[NTDIVNP];
};

typedef struct dcomplex_cell_s dcomplex_cell_t;
struct dcomplex_cell_s {
  dcomplex cell[NTDIVNP];
};

/*
#define twid(z,y,x) twiddle_ptr[z*d1*d0+y*d0+x]
#define u0(z,y,x)   u0_ptr[z*d1*d0+y*d0+x]
#define u1(z,y,x)   u1_ptr[z*d1*d0+y*d0+x]
#define x(z,y,x)    x_ptr[z*d1*d0+y*d0+x]
#define xout(z,y,x) xout_ptr[z*d1*d0+y*d0+x]
*/

#define twid(z,y,x) twiddle_ptr[z*d[1]*d[0]+y*d[0]+x]
#define u0(z,y,x)   u0_ptr[z*d[1]*d[0]+y*d[0]+x]
#define u1(z,y,x)   u1_ptr[z*d[1]*d[0]+y*d[0]+x]
#define x(z,y,x)    x_ptr[z*d1*d0+y*d0+x]
#define xout(z,y,x) xout_ptr[z*d1*d0+y*d0+x]

void setup_globals(int, int, int);

/*
void cffts1_comp (int is, int d[3],
       dcomplex x_ptr[NZ][NY][NX],
       dcomplex xout_ptr[NZ][NY][NX],
       dcomplex y0[NX][FFTBLOCKPAD],
       dcomplex y1[NX][FFTBLOCKPAD], int MYTHREAD);

void cffts2_comp (int is, int d[3],
       dcomplex x_ptr[NZ][NY][NX],
       dcomplex xout_ptr[NZ][NY][NX],
       dcomplex y0[NX][FFTBLOCKPAD],
       dcomplex y1[NX][FFTBLOCKPAD], int MYTHREAD);

void cffts3_comp (int is, int d[3],
       dcomplex x_ptr[NZ][NY][NX],
       dcomplex xout_ptr[NZ][NY][NX],
       dcomplex y0[NX][FFTBLOCKPAD],
       dcomplex y1[NX][FFTBLOCKPAD], int MYTHREAD);
*/


