
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"
#include "upcnpb.h"

void exchange_1( double g[],int k,int iex ) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------


#define g(i,j,k,m) g[(i-1)+(5)*((j+1)+(ISIZ1+4)*((k+1)+(ISIZ2+4)*(m-1)))]
      int i, j;

      int ptr;
       int comm_sum=0;
       int cnt;


#ifdef USE_BARRIER
      if ( iex == 0 || iex == 1) upc_barrier;
#endif

      if( iex == 0 ) {

          if( north != -1 ) {
#ifdef USE_BARRIER
              ptr = (bar_odd)? uptr(3) : uptr(1);
#else
              sync_testwait( north,0,-1 );
              ptr = uptr(1);
#endif
              upc_memget(ul_buffer, &u_buffer(north,ptr),
                         sizeof(double)*5*(jend-jst+1));
#ifndef USE_BARRIER
              sync_ackwait( north,0 );
#endif
              ptr = 1;
              for (j = jst; j <= jend; j++) {
                  g(1,0,j,k) = ul_buffer(ptr+0);
                  g(2,0,j,k) = ul_buffer(ptr+1);
                  g(3,0,j,k) = ul_buffer(ptr+2);
                  g(4,0,j,k) = ul_buffer(ptr+3);
                  g(5,0,j,k) = ul_buffer(ptr+4);
		  ptr = ptr + 5;
              }
          }

          if( west != -1 ) {
#ifdef USE_BARRIER
              ptr = (bar_odd)? uptr(4) : uptr(2);
#else
              sync_testwait( west,1,-1 );
              ptr = uptr(2);
#endif
              upc_memget(ul_buffer, &u_buffer(west,ptr),
                         sizeof(double)*5*(iend-ist+1));
#ifndef USE_BARRIER
              sync_ackwait( west,1 );
#endif
              ptr = 1;
              for (i = ist; i <= iend; i++) {
                  g(1,i,0,k) = ul_buffer(ptr+0);
                  g(2,i,0,k) = ul_buffer(ptr+1);
                  g(3,i,0,k) = ul_buffer(ptr+2);
                  g(4,i,0,k) = ul_buffer(ptr+3);
                  g(5,i,0,k) = ul_buffer(ptr+4);
		  ptr = ptr + 5;
              }
          }

      } else if( iex == 1 ) {

          if( south != -1 ) {
#ifdef USE_BARRIER
              ptr = (bar_odd)? uptr(3) : uptr(1);
#else
              sync_testwait( south,0,+1 );
              ptr = uptr(1);
#endif
              upc_memget(ul_buffer, &u_buffer(south,ptr),
                         sizeof(double)*5*(jend-jst+1));
#ifndef USE_BARRIER
              sync_ackwait( south,0 );
#endif
              ptr = 1;
              for (j = jst; j <= jend; j++) {
                  g(1,nx+1,j,k) = ul_buffer(ptr+0);
                  g(2,nx+1,j,k) = ul_buffer(ptr+1);
                  g(3,nx+1,j,k) = ul_buffer(ptr+2);
                  g(4,nx+1,j,k) = ul_buffer(ptr+3);
                  g(5,nx+1,j,k) = ul_buffer(ptr+4);
		  ptr = ptr + 5;
              }
          }

          if( east != -1 ) {
#ifdef USE_BARRIER
              ptr = (bar_odd)? uptr(4) : uptr(2);
#else
              sync_testwait( east,1,+1 );
              ptr = uptr(2);
#endif

              upc_memget(ul_buffer, &u_buffer(east,ptr),
                         sizeof(double)*5*(iend-ist+1));
              
#ifndef USE_BARRIER
              sync_ackwait( east,1 );
#endif
              ptr = 1;
              for (i = ist; i <= iend; i++) {
                  g(1,i,ny+1,k) = ul_buffer(ptr+0);
                  g(2,i,ny+1,k) = ul_buffer(ptr+1);
                  g(3,i,ny+1,k) = ul_buffer(ptr+2);
                  g(4,i,ny+1,k) = ul_buffer(ptr+3);
                  g(5,i,ny+1,k) = ul_buffer(ptr+4);
		  ptr = ptr + 5;
              }
          }

      } else if( iex == 2 ) {

          if( south != -1 ) {
#ifdef USE_BARRIER
              ptr = (!bar_odd)? uptr(3) : uptr(1);
#else
              sync_testnotify( south,0,0 );
              ptr = uptr(1);
#endif
              
              ll_buffer = (double *)&u_buffer(node,ptr);
              ptr = 1;
              for (j = jst; j <= jend; j++) {
                  ll_buffer(ptr+0) = g(1,nx,j,k);
                  ll_buffer(ptr+1) = g(2,nx,j,k);
                  ll_buffer(ptr+2) = g(3,nx,j,k);
                  ll_buffer(ptr+3) = g(4,nx,j,k);
                  ll_buffer(ptr+4) = g(5,nx,j,k);
		  ptr = ptr + 5;
              }
#ifndef USE_BARRIER
              sync_setnotify( south,0 );
#endif
          }

          if( east != -1 ) {
#ifdef USE_BARRIER
              ptr = (!bar_odd)? uptr(4) : uptr(2);
#else
              sync_testnotify( east,1,0 );
              ptr = uptr(2);
#endif

              ll_buffer = (double *)&u_buffer(node,ptr);
              ptr = 1;
              for (i = ist; i <= iend; i++) {
                  ll_buffer(ptr+0) = g(1,i,ny,k);
                  ll_buffer(ptr+1) = g(2,i,ny,k);
                  ll_buffer(ptr+2) = g(3,i,ny,k);
                  ll_buffer(ptr+3) = g(4,i,ny,k);
                  ll_buffer(ptr+4) = g(5,i,ny,k);
		  ptr = ptr + 5;
              }
#ifndef USE_BARRIER
              sync_setnotify( east,1 );
#endif
          }

      } else {

          if( north != -1 ) {
#ifdef USE_BARRIER
              ptr = (!bar_odd)? uptr(3) : uptr(1);
#else
              sync_testnotify( north,0,0 );
              ptr = uptr(1);
#endif
              ll_buffer = (double *)&u_buffer(node,ptr);
              ptr = 1;
              for (j = jst; j <= jend; j++) {
                  ll_buffer(ptr+0) = g(1,1,j,k);
                  ll_buffer(ptr+1) = g(2,1,j,k);
                  ll_buffer(ptr+2) = g(3,1,j,k);
                  ll_buffer(ptr+3) = g(4,1,j,k);
                  ll_buffer(ptr+4) = g(5,1,j,k);
		  ptr = ptr + 5;
              }
#ifndef USE_BARRIER
              sync_setnotify( north,0 );
#endif
          }

          if( west != -1 ) {
#ifdef USE_BARRIER
              ptr = (!bar_odd)? uptr(4) : uptr(2);
#else
              sync_testnotify( west,1,0 );
              ptr = uptr(2);
#endif

              ll_buffer = (double *)&u_buffer(node,ptr);
              ptr = 1;
              for (i = ist; i <= iend; i++) {
                  ll_buffer(ptr+0) = g(1,i,1,k);
                  ll_buffer(ptr+1) = g(2,i,1,k);
                  ll_buffer(ptr+2) = g(3,i,1,k);
                  ll_buffer(ptr+3) = g(4,i,1,k);
                  ll_buffer(ptr+4) = g(5,i,1,k);
		  ptr = ptr + 5;
              }
#ifndef USE_BARRIER
              sync_setnotify( west,1 );
#endif
          }

      }

#undef g
}



