
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"
#include "upcnpb.h"

void exchange_3(double g[],int iex) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   compute the right hand side based on exact solution
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  input parameters
//---------------------------------------------------------------------
#define g(i,j,k,m) g[(i-1)+(5)*((j+1)+(ISIZ1+4)*((k+1)+(ISIZ2+4)*(m-1)))]

//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int i, j, k;

      int ptr;



      if (iex==0) {
//---------------------------------------------------------------------
//   communicate in the south and north directions
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   send south
//---------------------------------------------------------------------
      if (south!=-1) {
          ptr = vptr(1);
          ll_buffer = (double *)&u_buffer(node,ptr);
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (j = 1; j <= ny; j++) {
              ll_buffer(ptr+0) = g(1,nx-1,j,k);
              ll_buffer(ptr+1) = g(2,nx-1,j,k);
              ll_buffer(ptr+2) = g(3,nx-1,j,k);
              ll_buffer(ptr+3) = g(4,nx-1,j,k);
              ll_buffer(ptr+4) = g(5,nx-1,j,k);
              ll_buffer(ptr+5) = g(1,nx,j,k);
              ll_buffer(ptr+6) = g(2,nx,j,k);
              ll_buffer(ptr+7) = g(3,nx,j,k);
              ll_buffer(ptr+8) = g(4,nx,j,k);
              ll_buffer(ptr+9) = g(5,nx,j,k);
	      ptr = ptr + 10;
            }
          }

        }

//---------------------------------------------------------------------
//   send north
//---------------------------------------------------------------------
        if (north!=-1) {
          ptr = vptr(2);
          ll_buffer = (double *)&u_buffer(node,ptr);
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (j = 1; j <= ny; j++) {
              ll_buffer(ptr+0) = g(1,2,j,k);
              ll_buffer(ptr+1) = g(2,2,j,k);
              ll_buffer(ptr+2) = g(3,2,j,k);
              ll_buffer(ptr+3) = g(4,2,j,k);
              ll_buffer(ptr+4) = g(5,2,j,k);
              ll_buffer(ptr+5) = g(1,1,j,k);
              ll_buffer(ptr+6) = g(2,1,j,k);
              ll_buffer(ptr+7) = g(3,1,j,k);
              ll_buffer(ptr+8) = g(4,1,j,k);
              ll_buffer(ptr+9) = g(5,1,j,k);
	      ptr = ptr + 10;
            }
          }

        }

        upc_barrier;

//---------------------------------------------------------------------
//   receive from south
//---------------------------------------------------------------------
        if (south!=-1) {

          ptr = vptr(2);
          upc_memget(ul_buffer, &u_buffer(south,ptr),
                     sizeof(double)*10*ny*nz);
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (j = 1; j <= ny; j++) {
              g(1,nx+2,j,k) = ul_buffer(ptr+0);
              g(2,nx+2,j,k) = ul_buffer(ptr+1);
              g(3,nx+2,j,k) = ul_buffer(ptr+2);
              g(4,nx+2,j,k) = ul_buffer(ptr+3);
              g(5,nx+2,j,k) = ul_buffer(ptr+4);
              g(1,nx+1,j,k) = ul_buffer(ptr+5);
              g(2,nx+1,j,k) = ul_buffer(ptr+6);
              g(3,nx+1,j,k) = ul_buffer(ptr+7);
              g(4,nx+1,j,k) = ul_buffer(ptr+8);
              g(5,nx+1,j,k) = ul_buffer(ptr+9);
	      ptr = ptr + 10;
            }
          }
        }

//---------------------------------------------------------------------
//   receive from north
//---------------------------------------------------------------------
        if (north!=-1) {

          ptr = vptr(1);
          upc_memget(ul_buffer, &u_buffer(north,ptr),
                     sizeof(double)*10*ny*nz);

          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (j = 1; j <= ny; j++) {
              g(1,-1,j,k) = ul_buffer(ptr+0);
              g(2,-1,j,k) = ul_buffer(ptr+1);
              g(3,-1,j,k) = ul_buffer(ptr+2);
              g(4,-1,j,k) = ul_buffer(ptr+3);
              g(5,-1,j,k) = ul_buffer(ptr+4);
              g(1, 0,j,k) = ul_buffer(ptr+5);
              g(2, 0,j,k) = ul_buffer(ptr+6);
              g(3, 0,j,k) = ul_buffer(ptr+7);
              g(4, 0,j,k) = ul_buffer(ptr+8);
              g(5, 0,j,k) = ul_buffer(ptr+9);
	      ptr = ptr + 10;
            }
          }

        }


      } else {

//---------------------------------------------------------------------
//   communicate in the east and west directions
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   send east
//---------------------------------------------------------------------
        if (east!=-1) {
          ptr = vptr(3);
          ll_buffer = (double *)&u_buffer(node,ptr);
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (i = 1; i <= nx; i++) {
              ll_buffer(ptr+0) = g(1,i,ny-1,k);
              ll_buffer(ptr+1) = g(2,i,ny-1,k);
              ll_buffer(ptr+2) = g(3,i,ny-1,k);
              ll_buffer(ptr+3) = g(4,i,ny-1,k);
              ll_buffer(ptr+4) = g(5,i,ny-1,k);
              ll_buffer(ptr+5) = g(1,i,ny,k);
              ll_buffer(ptr+6) = g(2,i,ny,k);
              ll_buffer(ptr+7) = g(3,i,ny,k);
              ll_buffer(ptr+8) = g(4,i,ny,k);
              ll_buffer(ptr+9) = g(5,i,ny,k);
	      ptr = ptr + 10;
            }
          }

        }

//---------------------------------------------------------------------
//   send west
//---------------------------------------------------------------------
        if (west!=-1) {
          ptr = vptr(4);
          ll_buffer = (double *)&u_buffer(node,ptr);
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (i = 1; i <= nx; i++) {
              ll_buffer(ptr+0) = g(1,i,2,k);
              ll_buffer(ptr+1) = g(2,i,2,k);
              ll_buffer(ptr+2) = g(3,i,2,k);
              ll_buffer(ptr+3) = g(4,i,2,k);
              ll_buffer(ptr+4) = g(5,i,2,k);
              ll_buffer(ptr+5) = g(1,i,1,k);
              ll_buffer(ptr+6) = g(2,i,1,k);
              ll_buffer(ptr+7) = g(3,i,1,k);
              ll_buffer(ptr+8) = g(4,i,1,k);
              ll_buffer(ptr+9) = g(5,i,1,k);
	      ptr = ptr + 10;
            }
          }

        }

        upc_barrier;

//---------------------------------------------------------------------
//   receive from east
//---------------------------------------------------------------------
        if (east!=-1) {

          ptr = vptr(4);
          upc_memget(ul_buffer, &u_buffer(east,ptr),
                     sizeof(double)*10*nx*nz);
          
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (i = 1; i <= nx; i++) {
              g(1,i,ny+2,k) = ul_buffer(ptr+0);
              g(2,i,ny+2,k) = ul_buffer(ptr+1);
              g(3,i,ny+2,k) = ul_buffer(ptr+2);
              g(4,i,ny+2,k) = ul_buffer(ptr+3);
              g(5,i,ny+2,k) = ul_buffer(ptr+4);
              g(1,i,ny+1,k) = ul_buffer(ptr+5);
              g(2,i,ny+1,k) = ul_buffer(ptr+6);
              g(3,i,ny+1,k) = ul_buffer(ptr+7);
              g(4,i,ny+1,k) = ul_buffer(ptr+8);
              g(5,i,ny+1,k) = ul_buffer(ptr+9);
	      ptr = ptr + 10;
            }
          }

        }

//---------------------------------------------------------------------
//   receive from west
//---------------------------------------------------------------------
        if (west!=-1) {

          ptr = vptr(3);
          upc_memget(ul_buffer, &u_buffer(west,ptr),
                     sizeof(double)*10*nx*nz);
          ptr = 1;
          for (k = 1; k <= nz; k++) {
            for (i = 1; i <= nx; i++) {
              g(1,i,-1,k) = ul_buffer(ptr+0);
              g(2,i,-1,k) = ul_buffer(ptr+1);
              g(3,i,-1,k) = ul_buffer(ptr+2);
              g(4,i,-1,k) = ul_buffer(ptr+3);
              g(5,i,-1,k) = ul_buffer(ptr+4);
              g(1,i, 0,k) = ul_buffer(ptr+5);
              g(2,i, 0,k) = ul_buffer(ptr+6);
              g(3,i, 0,k) = ul_buffer(ptr+7);
              g(4,i, 0,k) = ul_buffer(ptr+8);
              g(5,i, 0,k) = ul_buffer(ptr+9);
	      ptr = ptr + 10;
            }
          }

        }


      }


      return;
#undef g
}
