
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"

void setbv() {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   set the boundary values of dependent variables
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//   local variables
//---------------------------------------------------------------------
      int i, j, k;
      int iglob, jglob;

//---------------------------------------------------------------------
//   set the dependent variable values along the top and bottom faces
//---------------------------------------------------------------------
      for (j = 1; j <= ny; j++) {
         jglob = jpt + j;
         for (i = 1; i <= nx; i++) {
           iglob = ipt + i;
            exact( iglob, jglob, 1, &u( 1, i, j, 1 ) );
            exact( iglob, jglob, nz, &u( 1, i, j, nz ) );
         }
      }

//---------------------------------------------------------------------
//   set the dependent variable values along north and south faces
//---------------------------------------------------------------------
      if (west==-1) {
         for (k = 1; k <= nz; k++) {
            for (i = 1; i <= nx; i++) {
               iglob = ipt + i;
               exact( iglob, 1, k, &u( 1, i, 1, k ) );
            }
         }
      }

      if (east==-1) {
          for (k = 1; k <= nz; k++) {
             for (i = 1; i <= nx; i++) {
                iglob = ipt + i;
                exact( iglob, ny0, k, &u( 1, i, ny, k ) );
             }
          }
      }

//---------------------------------------------------------------------
//   set the dependent variable values along east and west faces
//---------------------------------------------------------------------
      if (north==-1) {
         for (k = 1; k <= nz; k++) {
            for (j = 1; j <= ny; j++) {
               jglob = jpt + j;
               exact( 1, jglob, k, &u( 1, 1, j, k ) );
            }
         }
      }

      if (south==-1) {
         for (k = 1; k <= nz; k++) {
            for (j = 1; j <= ny; j++) {
                  jglob = jpt + j;
            exact( nx0, jglob, k, &u( 1, nx, j, k ) );
            }
         }
      }

      return;
}
