#ifndef __UPCNPB_H
#define __UPCNPB_H

//---------------------------------------------------------------------
//---------------------------------------------------------------------

#include <upc_relaxed.h>
#include "../common/mupc_reduce.h"

#define BUFSIZE (2*ISIZ1+22*ISIZ2+2*ISIZ3+40*ISIZ2*ISIZ3+4)

#define u_buffer(n,m) u_buffer[n].slice[m-1]
#define ul_buffer(m) ul_buffer[m-1]
#define ll_buffer(m) ll_buffer[m-1]
#define uptr(m) uptr[m-1]
#define wptr(m) wptr[m-1]
#define vptr(m) vptr[m-1]

typedef struct sh_buf_s {
   double slice[BUFSIZE];
} sh_buf_t;

#ifdef G_MAIN
      int           node, no_nodes, root;
      int           dp_type;

shared sh_buf_t *u_buffer;
shared int *comm_count;

      double    ul_buffer[ISIZ2*ISIZ3*10], *ll_buffer;
      int       uptr[4], wptr[4], vptr[4];
#ifdef USE_BARRIER
      int       bar_odd;
#endif

#else /*G_MAIN*/
extern int           node, no_nodes, root;
extern int           dp_type;

extern shared sh_buf_t *u_buffer;
extern shared int *comm_count;

extern double   ul_buffer[ISIZ2*ISIZ3*10], *ll_buffer;
extern int      uptr[4], wptr[4], vptr[4];
#ifdef USE_BARRIER
extern int      bar_odd;
#endif

#endif /*G_MAIN*/

#ifndef USE_BARRIER
extern void sync_init(void);
extern void sync_testwait(int node, int dir, int sdir);
extern void sync_ackwait(int node, int dir);
extern void sync_testnotify(int node, int dir, int sdir);
extern void sync_setnotify(int node, int dir);
#endif


#endif
