
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#ifndef __UPCNPB_H
#define __UPCNPB_H

#include <upc_relaxed.h>
#include "../common/mupc_reduce.h"

#define u_buffer(n,m) u_buffer[n].slice[m]
#define ul_buffer(m) ul_buffer[m-1]

#ifdef USE_BARRIER
#define BUF_SIZE_TOT (BUF_SIZE+BUF_SIZZ*2)
#else
#define BUF_SIZE_TOT (BUF_SIZE+BUF_SIZZ*3)
#endif

typedef struct sh_buf_s {
   double slice[BUF_SIZE_TOT];
} sh_buf_t;


#ifdef G_MAIN
      int           node, no_nodes, total_nodes, root;
      int           active, dp_type;

//---------------------------------------------------------------------
// smp communication buffer
//---------------------------------------------------------------------
shared sh_buf_t *u_buffer;
      double  ul_buffer[BUF_SIZE];
      int     buffoff[3], buff_id;
#else
extern int           node, no_nodes, total_nodes, root;
extern int           active, dp_type;

extern shared sh_buf_t *u_buffer;
extern double  ul_buffer[BUF_SIZE];
extern int     buffoff[3], buff_id;
#endif

#ifndef USE_BARRIER
extern void sync_init(void);
extern void sync_testwait(int nid);
extern void sync_ackwait(int nid);
extern void sync_testnotify(int nid);
extern void sync_setnotify(int nid);
#endif

#endif
