//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"
#include "upcnpb.h"

shared [] int sh_ibuf[6];
shared [] double sh_rbuf[7];

void bcast_inputs() {

//---------------------------------------------------------------------
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int ierr;

//---------------------------------------------------------------------
//   root broadcasts the data
//   The data isn't contiguous or of the same type, so it's not
//   clear how to send it in the "MPI" way. 
//   We could pack the info into a buffer or we could create
//   an obscene datatype to handle it all at once. Since we only
//   broadcast the data once, just use a separate broadcast for
//   each piece. 
//---------------------------------------------------------------------
      if (no_nodes < 2) return;

      if (node == root) {
         sh_ibuf[0] = ipr;
         sh_ibuf[1] = inorm;
         sh_ibuf[2] = itmax;
         sh_ibuf[3] = nx0;
         sh_ibuf[4] = ny0;
         sh_ibuf[5] = nz0;
         sh_rbuf[0] = dt;
         sh_rbuf[1] = omega;
         upc_memput(&sh_rbuf[2], tolrsd, sizeof(double)*5);
      }

      upc_barrier;

      if (node != root) {
         ipr   = sh_ibuf[0];
         inorm = sh_ibuf[1];
         itmax = sh_ibuf[2];
         nx0   = sh_ibuf[3];
         ny0   = sh_ibuf[4];
         nz0   = sh_ibuf[5];
         dt    = sh_rbuf[0];
         omega = sh_rbuf[1];
         upc_memget(tolrsd, &sh_rbuf[2], sizeof(double)*5);
      }

      return;
}


