
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include <math.h>
#include "npbparams.h"
#include "upcnpb.h"

void l2norm ( int ldx, int ldy, int ldz, 
                          int nx0, int ny0, int nz0,
                          int ist, int iend, 
                          int jst, int jend,
                          double v[], double sum[] ) {
//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   to compute the l2-norm of vector v.
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  input parameters
//---------------------------------------------------------------------
#define v(i,j,k,m) v[(i-1)+(5)*((j+1)+(ldx+4)*((k+1)+(ldy+4)*(m-1)))]
#define sum(i) sum[i-1]

//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int i, j, k, m;
      double  dummy[5];
#define dummy(i) dummy[i-1]

      int IERROR;


      for (m = 1; m <= 5; m++) {
         dummy(m) = 0.0e+00;
      }

      for (k = 2; k <= nz0-1; k++) {
         for (j = jst; j <= jend; j++) {
            for (i = ist; i <= iend; i++) {
               for (m = 1; m <= 5; m++) {
                  dummy(m) = dummy(m) + v(m,i,j,k) * v(m,i,j,k);
               }
            }
         }
      }

//---------------------------------------------------------------------
//   compute the global sum of individual contributions to dot product.
//---------------------------------------------------------------------
      mupc_reduce_r8( dummy, sum, 5,
                      SMP_OPR_SUM, -1 );

      for (m = 1; m <= 5; m++) {
         sum(m) = sqrt ( sum(m) / ( (nx0-2)*(ny0-2)*(nz0-2) ) );
      }

      return;
#undef v
#undef sum
#undef dummy
}
