#include <stdio.h>
#include <stdlib.h>
#include <upc.h>

#include "tree.h"


#define DIM_RAND_NUM 16


shared [] Content *shared[1] rand_num[THREADS];
Tree *shared[] Mytree;

int main() {
    int dim_local, i, it;
    Params op;
/*  allocate and initialize input data */
    op.iadd = MYTHREAD + 1;
    dim_local = DIM_RAND_NUM / THREADS; 
    rand_num[MYTHREAD] = (shared [] Content *) upc_alloc(dim_local*sizeof(Content));
    upc_barrier;
    if (MYTHREAD == 0) {
      for (it=0; it<THREADS; it++) {
        for (i=0; i<dim_local; i++) {
          rand_num[it][i].c = rand();
	}
      }
    } 
    upc_barrier;
/*  initialize and fill tree structure */     
    if (MYTHREAD == 0) Mytree = Tree_init();
    upc_barrier;
    for (i=0; i<dim_local; i++) {
//        printf("Value on thread %i is %i\n",(int) MYTHREAD,
//                               (int) rand_num[MYTHREAD][i].c);
	insert(Mytree, (Content *) &rand_num[MYTHREAD][i]);
    }
    upc_barrier;
    if (MYTHREAD == 0) {
      printf("Number of entries: %i \n",dim_local*THREADS);
      printf("Before processing: \n");
      print_tree(Mytree);
    }
    upc_barrier;
    traverse(Mytree, &op);
    upc_barrier;
    if (MYTHREAD == 0) {
      printf("After processing: \n");
      print_tree(Mytree);
    }
    upc_barrier;
//
//  Would need to call a destructor for Mytree here if it existed
//
    upc_free(rand_num[MYTHREAD]);
}
