#include <stdio.h>
#include <stdlib.h>
#include <upc.h>

#include "tree.h"

Tree *Tree_init() {
  Tree *this;
  this = (Tree *) upc_alloc(sizeof(Tree));
  this->lk = upc_global_lock_alloc();
  this->data = (shared [] Content *) upc_alloc(sizeof(Content));
  this->data->c = -1;
  this->left = NULL;
  this->right = NULL;
  return this;
}

void insert(Tree *this, Content *stuff) {
  Content ct;
  upc_lock(this->lk);
  if (this->left) {
     upc_unlock(this->lk);
     upc_memget(&ct, this->data, sizeof(Content));
     if (lessthan(&ct, stuff)) {
       insert((Tree *) this->left, stuff);
     } else {
       insert((Tree *) this->right, stuff);
     }
  } else {
    this->left = (shared [] struct tree *) Tree_init();
    this->right = (shared [] struct tree *) Tree_init();
    upc_memput(this->data, stuff, sizeof(Content));
    upc_unlock(this->lk);
  }  
}

void traverse(Tree *this, Params *op) {
  if (this->data) {
    if (upc_threadof(this->data) == MYTHREAD) { 
// we're accessing data locally, so casting to 
// a local pointer is OK
      process((Content *) this->data, op);
    }
    traverse((Tree *) this->left, op);
    traverse((Tree *) this->right, op);
  }
}

// Note: a destructor has not been implemented

void print_tree(Tree *this) {
  if (this->data) {
     print_tree((Tree *) this->right);
     if (this->data->c > -1) printf("--> %i on thread %i\n",this->data->c,
                                     (int) upc_threadof(this->data));
     print_tree((Tree *) this->left);
  }
}
