module mod_test
contains 
  double precision function t_sum(x, y)
    double precision, intent(in) :: x, y
    t_sum = x + y
  end function t_sum
  double precision function t_max(x, y)
    double precision, intent(in) :: x, y
    t_max = max(x, y)
  end function t_max
end module mod_test
program test_reduction
  use mod_reduction
  use mod_test
  implicit none

  double precision :: x
  double precision :: res, rt
  integer :: i,me

  me = this_image()
  rt = dble(num_images())
  x = dble(me)

!  write(*, *) 'x on image ', me, ' is ', x

  res = caf_reduce(x, t_sum)

  if (abs(res - rt*(rt+1)/2)/abs(res) > 1.0d-12) then
     write(*,'(''caf_reduce: incorrect sum result on image '',i0,'':'',F8.2)') me, res
!  else
!     write(*,'(''caf_reduce: correct sum result on image '',i0,'':'',F8.2)') me, res
  end if

  res = caf_prefix_reduce(x, t_sum)
  rt = dble(me)

  if (abs(res - rt*(rt+1)/2)/abs(res) > 1.0d-12) then
     write(*,'(''caf_prefix_reduce: incorrect sum result on image '',i0,'':'',F8.2)') me, res
  end if


  x = 1.0d0
  rt = dble(num_images())
  res = caf_reduce(x, t_sum)

  if (abs(res - rt)/abs(res) > 1.0d-12) then
     write(*,'(''caf_reduce: incorrect sum result on image '',i0,'':'',F8.2)') me, res
!  else
!    write(*,'(''caf_reduce: correct sum result on image '',i0,'':'',F8.2)') me, res
  end if

  do i = 2, num_images()
     x = - (dble(me-i) - 0.1d0)**2 + 1.2d0 
     res = caf_reduce(x, t_max)
     
     if (abs(res - 1.19d0)/abs(res) > 1.0d-12) then
        write(*,'(''caf_reduce: incorrect max result on image '',i0,'':'',F8.2)') me, res
     end if
  end do


end program test_reduction
