program triangular
  implicit none
!
! A(i,j) is addressed as a(i)%row(j) 
!
  type :: tri_matrix
    real, allocatable :: row(:)
  end type
  type(tri_matrix), allocatable :: a(:)
!
  integer :: n
  integer ::  i, j, i_row
!
  read(*, *) n, i_row
!
! create triangular matrix :
  allocate(a(n))
  do i = 1, n
    allocate(a(i)%row(n - i + 1))
  end do
!
! initialize matrix A(i, j) = i + j : 
  do i = 1, n
    do j = 1, n - i + 1
       a(i)%row(j) = real(i) + real(j)
    end do
  end do
!
! write row number i_row to standard output
  write(*, fmt='('' Row '',i0,'':'')') i_row
  if (i_row <= n .and. i_row > 0) then
    do j = 1, n - i_row + 1
      write(*, fmt='(F12.1)') a(i_row)%row(j)
    end do
  end if
!
! clean up
  deallocate(a)  ! implies deallocation of components
end program
  
